(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.StructuredReactHook = {}, global.React));
}(this, (function (exports, React) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  var log = function log() {
    if (log.debugger) {
      var _console;

      (_console = console).log.apply(_console, arguments);
    }
  };
  log.debugger = false;

  var getReducerType = function getReducerType(stateKey) {
    return "set" + stateKey.charAt(0).toUpperCase() + stateKey.slice(1);
  }; // const getStateKey = (type) => `${type.charAt(3).toLowerCase()}${type.slice(4)}`


  var reducerHelper = function reducerHelper(createReducer) {
    return function (state, action) {
      var reducerModel = createReducer(state);
      log(reducerModel, 5);

      if (reducerModel[action[0]] === undefined) {
        throw new Error("\u4E0D\u5B58\u5728\u7684 action => " + action[0] + ", \u6E05\u6838\u5BF9\u4EE3\u7801");
      }

      var result = reducerModel[action[0]](action[1]);

      if (reducerHelper.debugger) {
        console.group(action[0]);
        console.log('prev store.state =>', state);
        console.log('next state =>', action[1]);
        console.groupEnd();
      }

      return _extends({}, state, result);
    };
  };
  reducerHelper.debugger = true;
  var createReducer = function createReducer(stateKeys) {
    return function () {
      var reducer = {
        setState: function setState(nextState) {
          return _extends({}, nextState);
        }
      };
      stateKeys.forEach(function (stateKey) {
        var type = getReducerType(stateKey);

        reducer[type] = function (payload) {
          var _ref2;

          if (Array.isArray(payload)) {
            var _ref;

            return _ref = {}, _ref[stateKey] = payload.map(function (p) {
              return p;
            }), _ref;
          }

          return _ref2 = {}, _ref2[stateKey] = payload, _ref2;
        };
      });
      return reducer;
    };
  };

  function isFunction(value) {
    return typeof value === 'function';
  }

  function createRC(stateKeys, dispatch, state) {
    var rc = {
      setState: function setState(nextState) {
        if (isFunction(nextState)) {
          dispatch(['setState', nextState(state)]);
        }

        var nextStateKeys = Object.keys(nextState);
        var ghostKeys = nextStateKeys.filter(function (key) {
          return !stateKeys.includes(key);
        });

        if (ghostKeys.length) {
          throw new Error("\u4E0D\u5B58\u5728\u7684 state => [" + ghostKeys.toString() + "], \u8BF7\u786E\u4FDDsetState\u4E2D\u66F4\u65B0\u7684state\u5728initState\u4E2D\u5DF2\u7ECF\u58F0\u660E");
        } else {
          dispatch(['setState', nextState]);
        }
      }
    };
    stateKeys.forEach(function (stateKey) {
      var type = getReducerType(stateKey);

      rc[type] = function (payload) {
        if (isFunction(payload)) {
          console.log(payload(state[stateKey]), 67);
          dispatch([type, payload(state[stateKey])]);
        } else {
          dispatch([type, payload]);
        }
      };
    });
    return rc;
  }

  function initStateMetaHandler(_ref) {
    var initStateMeta = _ref.initState,
        ref = _ref.ref;
    var initStateMetaIsArray = Array.isArray(initStateMeta);
    var initState;
    var init;

    if (initStateMetaIsArray) {
      initState = initStateMeta[0];
      init = initStateMeta[1];
    } else {
      initState = initStateMeta;

      init = function init(state) {
        return state;
      };
    }

    var stateKeys = Object.keys(initState);
    var refKeys;

    if (ref) {
      refKeys = Object.keys(ref);
    }

    return {
      initState: initState,
      stateKeys: stateKeys,
      refKeys: refKeys,
      init: init
    };
  }

  var AppContext = React__default['default'].createContext();
  function createStoreContext(storeConfig) {
    storeConfig.name = 'storeContext';
    return createStore(storeConfig);
  }

  function createCommonjsModule(fn, basedir, module) {
  	return module = {
  		path: basedir,
  		exports: {},
  		require: function (path, base) {
  			return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
  		}
  	}, fn(module, module.exports), module.exports;
  }

  function commonjsRequire () {
  	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
  }

  var runtime_1 = createCommonjsModule(function (module) {
  /**
   * Copyright (c) 2014-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var runtime = (function (exports) {

    var Op = Object.prototype;
    var hasOwn = Op.hasOwnProperty;
    var undefined$1; // More compressible than void 0.
    var $Symbol = typeof Symbol === "function" ? Symbol : {};
    var iteratorSymbol = $Symbol.iterator || "@@iterator";
    var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
    var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

    function define(obj, key, value) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
      return obj[key];
    }
    try {
      // IE 8 has a broken Object.defineProperty that only works on DOM objects.
      define({}, "");
    } catch (err) {
      define = function(obj, key, value) {
        return obj[key] = value;
      };
    }

    function wrap(innerFn, outerFn, self, tryLocsList) {
      // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
      var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
      var generator = Object.create(protoGenerator.prototype);
      var context = new Context(tryLocsList || []);

      // The ._invoke method unifies the implementations of the .next,
      // .throw, and .return methods.
      generator._invoke = makeInvokeMethod(innerFn, self, context);

      return generator;
    }
    exports.wrap = wrap;

    // Try/catch helper to minimize deoptimizations. Returns a completion
    // record like context.tryEntries[i].completion. This interface could
    // have been (and was previously) designed to take a closure to be
    // invoked without arguments, but in all the cases we care about we
    // already have an existing method we want to call, so there's no need
    // to create a new function object. We can even get away with assuming
    // the method takes exactly one argument, since that happens to be true
    // in every case, so we don't have to touch the arguments object. The
    // only additional allocation required is the completion record, which
    // has a stable shape and so hopefully should be cheap to allocate.
    function tryCatch(fn, obj, arg) {
      try {
        return { type: "normal", arg: fn.call(obj, arg) };
      } catch (err) {
        return { type: "throw", arg: err };
      }
    }

    var GenStateSuspendedStart = "suspendedStart";
    var GenStateSuspendedYield = "suspendedYield";
    var GenStateExecuting = "executing";
    var GenStateCompleted = "completed";

    // Returning this object from the innerFn has the same effect as
    // breaking out of the dispatch switch statement.
    var ContinueSentinel = {};

    // Dummy constructor functions that we use as the .constructor and
    // .constructor.prototype properties for functions that return Generator
    // objects. For full spec compliance, you may wish to configure your
    // minifier not to mangle the names of these two functions.
    function Generator() {}
    function GeneratorFunction() {}
    function GeneratorFunctionPrototype() {}

    // This is a polyfill for %IteratorPrototype% for environments that
    // don't natively support it.
    var IteratorPrototype = {};
    IteratorPrototype[iteratorSymbol] = function () {
      return this;
    };

    var getProto = Object.getPrototypeOf;
    var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
    if (NativeIteratorPrototype &&
        NativeIteratorPrototype !== Op &&
        hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
      // This environment has a native %IteratorPrototype%; use it instead
      // of the polyfill.
      IteratorPrototype = NativeIteratorPrototype;
    }

    var Gp = GeneratorFunctionPrototype.prototype =
      Generator.prototype = Object.create(IteratorPrototype);
    GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
    GeneratorFunctionPrototype.constructor = GeneratorFunction;
    GeneratorFunction.displayName = define(
      GeneratorFunctionPrototype,
      toStringTagSymbol,
      "GeneratorFunction"
    );

    // Helper for defining the .next, .throw, and .return methods of the
    // Iterator interface in terms of a single ._invoke method.
    function defineIteratorMethods(prototype) {
      ["next", "throw", "return"].forEach(function(method) {
        define(prototype, method, function(arg) {
          return this._invoke(method, arg);
        });
      });
    }

    exports.isGeneratorFunction = function(genFun) {
      var ctor = typeof genFun === "function" && genFun.constructor;
      return ctor
        ? ctor === GeneratorFunction ||
          // For the native GeneratorFunction constructor, the best we can
          // do is to check its .name property.
          (ctor.displayName || ctor.name) === "GeneratorFunction"
        : false;
    };

    exports.mark = function(genFun) {
      if (Object.setPrototypeOf) {
        Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
      } else {
        genFun.__proto__ = GeneratorFunctionPrototype;
        define(genFun, toStringTagSymbol, "GeneratorFunction");
      }
      genFun.prototype = Object.create(Gp);
      return genFun;
    };

    // Within the body of any async function, `await x` is transformed to
    // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
    // `hasOwn.call(value, "__await")` to determine if the yielded value is
    // meant to be awaited.
    exports.awrap = function(arg) {
      return { __await: arg };
    };

    function AsyncIterator(generator, PromiseImpl) {
      function invoke(method, arg, resolve, reject) {
        var record = tryCatch(generator[method], generator, arg);
        if (record.type === "throw") {
          reject(record.arg);
        } else {
          var result = record.arg;
          var value = result.value;
          if (value &&
              typeof value === "object" &&
              hasOwn.call(value, "__await")) {
            return PromiseImpl.resolve(value.__await).then(function(value) {
              invoke("next", value, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            });
          }

          return PromiseImpl.resolve(value).then(function(unwrapped) {
            // When a yielded Promise is resolved, its final value becomes
            // the .value of the Promise<{value,done}> result for the
            // current iteration.
            result.value = unwrapped;
            resolve(result);
          }, function(error) {
            // If a rejected Promise was yielded, throw the rejection back
            // into the async generator function so it can be handled there.
            return invoke("throw", error, resolve, reject);
          });
        }
      }

      var previousPromise;

      function enqueue(method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function(resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }

        return previousPromise =
          // If enqueue has been called before, then we want to wait until
          // all previous Promises have been resolved before calling invoke,
          // so that results are always delivered in the correct order. If
          // enqueue has not been called before, then it is important to
          // call invoke immediately, without waiting on a callback to fire,
          // so that the async generator function has the opportunity to do
          // any necessary setup in a predictable way. This predictability
          // is why the Promise constructor synchronously invokes its
          // executor callback, and why async functions synchronously
          // execute code before the first await. Since we implement simple
          // async functions in terms of async generators, it is especially
          // important to get this right, even though it requires care.
          previousPromise ? previousPromise.then(
            callInvokeWithMethodAndArg,
            // Avoid propagating failures to Promises returned by later
            // invocations of the iterator.
            callInvokeWithMethodAndArg
          ) : callInvokeWithMethodAndArg();
      }

      // Define the unified helper method that is used to implement .next,
      // .throw, and .return (see defineIteratorMethods).
      this._invoke = enqueue;
    }

    defineIteratorMethods(AsyncIterator.prototype);
    AsyncIterator.prototype[asyncIteratorSymbol] = function () {
      return this;
    };
    exports.AsyncIterator = AsyncIterator;

    // Note that simple async functions are implemented on top of
    // AsyncIterator objects; they just return a Promise for the value of
    // the final result produced by the iterator.
    exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
      if (PromiseImpl === void 0) PromiseImpl = Promise;

      var iter = new AsyncIterator(
        wrap(innerFn, outerFn, self, tryLocsList),
        PromiseImpl
      );

      return exports.isGeneratorFunction(outerFn)
        ? iter // If outerFn is a generator, return the full iterator.
        : iter.next().then(function(result) {
            return result.done ? result.value : iter.next();
          });
    };

    function makeInvokeMethod(innerFn, self, context) {
      var state = GenStateSuspendedStart;

      return function invoke(method, arg) {
        if (state === GenStateExecuting) {
          throw new Error("Generator is already running");
        }

        if (state === GenStateCompleted) {
          if (method === "throw") {
            throw arg;
          }

          // Be forgiving, per 25.3.3.3.3 of the spec:
          // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
          return doneResult();
        }

        context.method = method;
        context.arg = arg;

        while (true) {
          var delegate = context.delegate;
          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);
            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if (context.method === "next") {
            // Setting context._sent for legacy support of Babel's
            // function.sent implementation.
            context.sent = context._sent = context.arg;

          } else if (context.method === "throw") {
            if (state === GenStateSuspendedStart) {
              state = GenStateCompleted;
              throw context.arg;
            }

            context.dispatchException(context.arg);

          } else if (context.method === "return") {
            context.abrupt("return", context.arg);
          }

          state = GenStateExecuting;

          var record = tryCatch(innerFn, self, context);
          if (record.type === "normal") {
            // If an exception is thrown from innerFn, we leave state ===
            // GenStateExecuting and loop back for another invocation.
            state = context.done
              ? GenStateCompleted
              : GenStateSuspendedYield;

            if (record.arg === ContinueSentinel) {
              continue;
            }

            return {
              value: record.arg,
              done: context.done
            };

          } else if (record.type === "throw") {
            state = GenStateCompleted;
            // Dispatch the exception by looping back around to the
            // context.dispatchException(context.arg) call above.
            context.method = "throw";
            context.arg = record.arg;
          }
        }
      };
    }

    // Call delegate.iterator[context.method](context.arg) and handle the
    // result, either by returning a { value, done } result from the
    // delegate iterator, or by modifying context.method and context.arg,
    // setting context.delegate to null, and returning the ContinueSentinel.
    function maybeInvokeDelegate(delegate, context) {
      var method = delegate.iterator[context.method];
      if (method === undefined$1) {
        // A .throw or .return when the delegate iterator has no .throw
        // method always terminates the yield* loop.
        context.delegate = null;

        if (context.method === "throw") {
          // Note: ["return"] must be used for ES3 parsing compatibility.
          if (delegate.iterator["return"]) {
            // If the delegate iterator has a return method, give it a
            // chance to clean up.
            context.method = "return";
            context.arg = undefined$1;
            maybeInvokeDelegate(delegate, context);

            if (context.method === "throw") {
              // If maybeInvokeDelegate(context) changed context.method from
              // "return" to "throw", let that override the TypeError below.
              return ContinueSentinel;
            }
          }

          context.method = "throw";
          context.arg = new TypeError(
            "The iterator does not provide a 'throw' method");
        }

        return ContinueSentinel;
      }

      var record = tryCatch(method, delegate.iterator, context.arg);

      if (record.type === "throw") {
        context.method = "throw";
        context.arg = record.arg;
        context.delegate = null;
        return ContinueSentinel;
      }

      var info = record.arg;

      if (! info) {
        context.method = "throw";
        context.arg = new TypeError("iterator result is not an object");
        context.delegate = null;
        return ContinueSentinel;
      }

      if (info.done) {
        // Assign the result of the finished delegate to the temporary
        // variable specified by delegate.resultName (see delegateYield).
        context[delegate.resultName] = info.value;

        // Resume execution at the desired location (see delegateYield).
        context.next = delegate.nextLoc;

        // If context.method was "throw" but the delegate handled the
        // exception, let the outer generator proceed normally. If
        // context.method was "next", forget context.arg since it has been
        // "consumed" by the delegate iterator. If context.method was
        // "return", allow the original .return call to continue in the
        // outer generator.
        if (context.method !== "return") {
          context.method = "next";
          context.arg = undefined$1;
        }

      } else {
        // Re-yield the result returned by the delegate method.
        return info;
      }

      // The delegate iterator is finished, so forget it and continue with
      // the outer generator.
      context.delegate = null;
      return ContinueSentinel;
    }

    // Define Generator.prototype.{next,throw,return} in terms of the
    // unified ._invoke helper method.
    defineIteratorMethods(Gp);

    define(Gp, toStringTagSymbol, "Generator");

    // A Generator should always return itself as the iterator object when the
    // @@iterator function is called on it. Some browsers' implementations of the
    // iterator prototype chain incorrectly implement this, causing the Generator
    // object to not be returned from this call. This ensures that doesn't happen.
    // See https://github.com/facebook/regenerator/issues/274 for more details.
    Gp[iteratorSymbol] = function() {
      return this;
    };

    Gp.toString = function() {
      return "[object Generator]";
    };

    function pushTryEntry(locs) {
      var entry = { tryLoc: locs[0] };

      if (1 in locs) {
        entry.catchLoc = locs[1];
      }

      if (2 in locs) {
        entry.finallyLoc = locs[2];
        entry.afterLoc = locs[3];
      }

      this.tryEntries.push(entry);
    }

    function resetTryEntry(entry) {
      var record = entry.completion || {};
      record.type = "normal";
      delete record.arg;
      entry.completion = record;
    }

    function Context(tryLocsList) {
      // The root entry object (effectively a try statement without a catch
      // or a finally block) gives us a place to store values thrown from
      // locations where there is no enclosing try statement.
      this.tryEntries = [{ tryLoc: "root" }];
      tryLocsList.forEach(pushTryEntry, this);
      this.reset(true);
    }

    exports.keys = function(object) {
      var keys = [];
      for (var key in object) {
        keys.push(key);
      }
      keys.reverse();

      // Rather than returning an object with a next method, we keep
      // things simple and return the next function itself.
      return function next() {
        while (keys.length) {
          var key = keys.pop();
          if (key in object) {
            next.value = key;
            next.done = false;
            return next;
          }
        }

        // To avoid creating an additional object, we just hang the .value
        // and .done properties off the next function object itself. This
        // also ensures that the minifier will not anonymize the function.
        next.done = true;
        return next;
      };
    };

    function values(iterable) {
      if (iterable) {
        var iteratorMethod = iterable[iteratorSymbol];
        if (iteratorMethod) {
          return iteratorMethod.call(iterable);
        }

        if (typeof iterable.next === "function") {
          return iterable;
        }

        if (!isNaN(iterable.length)) {
          var i = -1, next = function next() {
            while (++i < iterable.length) {
              if (hasOwn.call(iterable, i)) {
                next.value = iterable[i];
                next.done = false;
                return next;
              }
            }

            next.value = undefined$1;
            next.done = true;

            return next;
          };

          return next.next = next;
        }
      }

      // Return an iterator with no values.
      return { next: doneResult };
    }
    exports.values = values;

    function doneResult() {
      return { value: undefined$1, done: true };
    }

    Context.prototype = {
      constructor: Context,

      reset: function(skipTempReset) {
        this.prev = 0;
        this.next = 0;
        // Resetting context._sent for legacy support of Babel's
        // function.sent implementation.
        this.sent = this._sent = undefined$1;
        this.done = false;
        this.delegate = null;

        this.method = "next";
        this.arg = undefined$1;

        this.tryEntries.forEach(resetTryEntry);

        if (!skipTempReset) {
          for (var name in this) {
            // Not sure about the optimal order of these conditions:
            if (name.charAt(0) === "t" &&
                hasOwn.call(this, name) &&
                !isNaN(+name.slice(1))) {
              this[name] = undefined$1;
            }
          }
        }
      },

      stop: function() {
        this.done = true;

        var rootEntry = this.tryEntries[0];
        var rootRecord = rootEntry.completion;
        if (rootRecord.type === "throw") {
          throw rootRecord.arg;
        }

        return this.rval;
      },

      dispatchException: function(exception) {
        if (this.done) {
          throw exception;
        }

        var context = this;
        function handle(loc, caught) {
          record.type = "throw";
          record.arg = exception;
          context.next = loc;

          if (caught) {
            // If the dispatched exception was caught by a catch block,
            // then let that catch block handle the exception normally.
            context.method = "next";
            context.arg = undefined$1;
          }

          return !! caught;
        }

        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          var record = entry.completion;

          if (entry.tryLoc === "root") {
            // Exception thrown outside of any try block that could handle
            // it, so set the completion value of the entire function to
            // throw the exception.
            return handle("end");
          }

          if (entry.tryLoc <= this.prev) {
            var hasCatch = hasOwn.call(entry, "catchLoc");
            var hasFinally = hasOwn.call(entry, "finallyLoc");

            if (hasCatch && hasFinally) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              } else if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }

            } else if (hasCatch) {
              if (this.prev < entry.catchLoc) {
                return handle(entry.catchLoc, true);
              }

            } else if (hasFinally) {
              if (this.prev < entry.finallyLoc) {
                return handle(entry.finallyLoc);
              }

            } else {
              throw new Error("try statement without catch or finally");
            }
          }
        }
      },

      abrupt: function(type, arg) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc <= this.prev &&
              hasOwn.call(entry, "finallyLoc") &&
              this.prev < entry.finallyLoc) {
            var finallyEntry = entry;
            break;
          }
        }

        if (finallyEntry &&
            (type === "break" ||
             type === "continue") &&
            finallyEntry.tryLoc <= arg &&
            arg <= finallyEntry.finallyLoc) {
          // Ignore the finally entry if control is not jumping to a
          // location outside the try/catch block.
          finallyEntry = null;
        }

        var record = finallyEntry ? finallyEntry.completion : {};
        record.type = type;
        record.arg = arg;

        if (finallyEntry) {
          this.method = "next";
          this.next = finallyEntry.finallyLoc;
          return ContinueSentinel;
        }

        return this.complete(record);
      },

      complete: function(record, afterLoc) {
        if (record.type === "throw") {
          throw record.arg;
        }

        if (record.type === "break" ||
            record.type === "continue") {
          this.next = record.arg;
        } else if (record.type === "return") {
          this.rval = this.arg = record.arg;
          this.method = "return";
          this.next = "end";
        } else if (record.type === "normal" && afterLoc) {
          this.next = afterLoc;
        }

        return ContinueSentinel;
      },

      finish: function(finallyLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.finallyLoc === finallyLoc) {
            this.complete(entry.completion, entry.afterLoc);
            resetTryEntry(entry);
            return ContinueSentinel;
          }
        }
      },

      "catch": function(tryLoc) {
        for (var i = this.tryEntries.length - 1; i >= 0; --i) {
          var entry = this.tryEntries[i];
          if (entry.tryLoc === tryLoc) {
            var record = entry.completion;
            if (record.type === "throw") {
              var thrown = record.arg;
              resetTryEntry(entry);
            }
            return thrown;
          }
        }

        // The context.catch method must only be called with a location
        // argument that corresponds to a known catch block.
        throw new Error("illegal catch attempt");
      },

      delegateYield: function(iterable, resultName, nextLoc) {
        this.delegate = {
          iterator: values(iterable),
          resultName: resultName,
          nextLoc: nextLoc
        };

        if (this.method === "next") {
          // Deliberately forget the last sent value so that we don't
          // accidentally pass it on to the delegate.
          this.arg = undefined$1;
        }

        return ContinueSentinel;
      }
    };

    // Regardless of whether this script is executing as a CommonJS module
    // or not, return the runtime object so that we can declare the variable
    // regeneratorRuntime in the outer scope, which allows this module to be
    // injected easily by `bin/regenerator --include-runtime script.js`.
    return exports;

  }(
    // If this script is executing as a CommonJS module, use module.exports
    // as the regeneratorRuntime namespace. Otherwise create a new empty
    // object. Either way, the resulting object will be used to initialize
    // the regeneratorRuntime variable at the top of this file.
     module.exports 
  ));

  try {
    regeneratorRuntime = runtime;
  } catch (accidentalStrictMode) {
    // This module should not be running in strict mode, so the above
    // assignment should always work unless something is misconfigured. Just
    // in case runtime.js accidentally runs in strict mode, we can escape
    // strict mode using a global Function call. This could conceivably fail
    // if a Content Security Policy forbids using Function, but in that case
    // the proper solution is to fix the accidental strict mode problem. If
    // you've misconfigured your bundler to force strict mode and applied a
    // CSP to forbid Function, and you're not willing to fix either of those
    // problems, please detail your unique predicament in a GitHub issue.
    Function("r", "regeneratorRuntime = r")(runtime);
  }
  });

  var regenerator = runtime_1;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  /* eslint-disable no-unused-vars */
  var logPlugin = function logPlugin(key, info, storeName, args, desc) {
    if (!logPlugin.debug) {
      return;
    }
    console.group(storeName + "." + key);
    var arg = args.length > 0 ? args : ['没有入参'];

    if (info) {
      var _console;

      (_console = console).debug.apply(_console, ["\u8BF4\u660E: " + info + " \u5165\u53C2:"].concat(arg));
    } else {
      var _console2;

      (_console2 = console).debug.apply(_console2, ['入参:'].concat(arg));
    }

    console.groupEnd();
  };
  logPlugin.debug = true;

  /* eslint-disable no-unused-vars */
  var rcsHooks = {
    controller: {
      beforeRunWithEnhancer: function beforeRunWithEnhancer(controllerKey, controllerEnhancer, name) {
        for (var _len = arguments.length, args = new Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
          args[_key - 3] = arguments[_key];
        }

        logPlugin(controllerKey, controllerEnhancer[0], name, args);
      },
      afterRunWithEnhancer: function afterRunWithEnhancer(result, controllerKey) {},
      beforeRun: function beforeRun(controllerKey, name) {
        for (var _len2 = arguments.length, args = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
          args[_key2 - 2] = arguments[_key2];
        }

        logPlugin(controllerKey, null, name, args);
      },
      afterRun: function afterRun(result, controllerKey) {}
    },
    service: {
      beforeRunWithEnhancer: function beforeRunWithEnhancer(serviceKey, serviceEnhancer, name) {
        for (var _len3 = arguments.length, args = new Array(_len3 > 3 ? _len3 - 3 : 0), _key3 = 3; _key3 < _len3; _key3++) {
          args[_key3 - 3] = arguments[_key3];
        }

        logPlugin(serviceKey, serviceEnhancer[0], name, args);
      },
      afterRunWithEnhancer: function afterRunWithEnhancer(result, serviceKey) {},
      beforeRun: function beforeRun(serviceKey, name) {
        for (var _len4 = arguments.length, args = new Array(_len4 > 2 ? _len4 - 2 : 0), _key4 = 2; _key4 < _len4; _key4++) {
          args[_key4 - 2] = arguments[_key4];
        }

        logPlugin(serviceKey, null, name, args);
      },
      afterRun: function afterRun(result, serviceKey) {}
    }
  };

  function createControllerBind(controller, callEffectContext) {
    log(callEffectContext);

    if (!controller) {
      throw new Error('任何一个 store 都不能没有 controller');
    }

    var controllerKeys = Object.keys(controller);
    var controllerBind = {};
    controllerKeys.forEach(function (controllerKey) {
      var isNotStartWithON = !controllerKey.startsWith('on');

      if (isNotStartWithON) {
        throw new Error(controllerKey + " \u547D\u540D\u5FC5\u987B\u4EE5 on \u5F00\u5934, \u540D\u8BCD + \u52A8\u8BCD\u7ED3\u5C3E");
      }
    });
    controllerKeys.forEach(function (controllerKey) {
      var controllerIsArray = Array.isArray(controller[controllerKey]);
      log(controller[controllerKey]);
      log(controllerIsArray);

      if (controllerIsArray) {
        controllerBind[controllerKey] = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee() {
          var _rcsHooks$controller, _controller$controlle;

          var _len,
              args,
              _key,
              result,
              _args = arguments;

          return regenerator.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  for (_len = _args.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                    args[_key] = _args[_key];
                  }

                  (_rcsHooks$controller = rcsHooks.controller).beforeRunWithEnhancer.apply(_rcsHooks$controller, [controllerKey, controller[controllerKey], callEffectContext.name].concat(args));

                  log(controller[controllerKey][1], callEffectContext);
                  _context.next = 5;
                  return (_controller$controlle = controller[controllerKey][1]).call.apply(_controller$controlle, [callEffectContext].concat(args));

                case 5:
                  result = _context.sent;
                  rcsHooks.controller.afterRunWithEnhancer(result, controllerKey);
                  return _context.abrupt("return", result);

                case 8:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));
      } else {
        controllerBind[controllerKey] = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee2() {
          var _rcsHooks$controller2, _controller$controlle2;

          var _len2,
              args,
              _key2,
              result,
              _args2 = arguments;

          return regenerator.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  for (_len2 = _args2.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                    args[_key2] = _args2[_key2];
                  }

                  (_rcsHooks$controller2 = rcsHooks.controller).beforeRun.apply(_rcsHooks$controller2, [controllerKey, callEffectContext.name].concat(args));

                  _context2.next = 4;
                  return (_controller$controlle2 = controller[controllerKey]).call.apply(_controller$controlle2, [callEffectContext].concat(args));

                case 4:
                  result = _context2.sent;
                  rcsHooks.controller.afterRun(result, controllerKey);
                  return _context2.abrupt("return", result);

                case 7:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));
      }
    });
    return controllerBind;
  }

  function createServiceBind(service, callEffectContext) {
    if (service) {
      var serviceBind = {};
      var serviceKeys = Object.keys(service);
      serviceKeys.forEach(function (serviceKey) {
        var serviceIsArray = Array.isArray(service[serviceKey]);

        if (serviceIsArray) {
          serviceBind[serviceKey] = function () {
            var _rcsHooks$service, _service$serviceKey$;

            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            (_rcsHooks$service = rcsHooks.service).beforeRunWithEnhancer.apply(_rcsHooks$service, [serviceKey, service[serviceKey], callEffectContext.name].concat(args));

            var res = (_service$serviceKey$ = service[serviceKey][1]).call.apply(_service$serviceKey$, [_extends({}, callEffectContext, {
              service: serviceBind
            })].concat(args));

            rcsHooks.service.afterRunWithEnhancer(res, serviceKey, service[serviceKey]);
            return res;
          };
        } else {
          serviceBind[serviceKey] = function () {
            var _rcsHooks$service2, _service$serviceKey;

            for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
              args[_key2] = arguments[_key2];
            }

            (_rcsHooks$service2 = rcsHooks.service).beforeRun.apply(_rcsHooks$service2, [serviceKey, callEffectContext.name].concat(args));

            var res = (_service$serviceKey = service[serviceKey]).call.apply(_service$serviceKey, [_extends({}, callEffectContext, {
              service: serviceBind
            })].concat(args));

            rcsHooks.service.afterRun(res, serviceKey);
            return res;
          };
        }
      });
      log(serviceBind);
      return serviceBind;
    }

    return {};
  }

  function createRefs(refsKeys, refs) {
    var refContext = {};

    if (refsKeys) {
      refsKeys.forEach(function (refKey) {
        refContext[refKey] = React.useRef(refs[refKey]);
      });
    }

    return refContext;
  }

  function createViewBind(view, viewContext) {
    if (!view) {
      return {};
    }

    var viewBind = {};
    var viewKeys = Object.keys(view);
    viewKeys.forEach(function (viewKey) {
      viewBind[viewKey] = view[viewKey].bind(viewContext);
    });
    return viewBind;
  }

  function createStoreInHook(_ref) {
    var stateKeys = _ref.stateKeys,
        dispatch = _ref.dispatch,
        state = _ref.state,
        refKeys = _ref.refKeys,
        ref = _ref.ref,
        name = _ref.name,
        context = _ref.context,
        service = _ref.service,
        controller = _ref.controller,
        view = _ref.view;
    var rc = createRC(stateKeys, dispatch, state);
    var refs = createRefs(refKeys, ref);
    var callEffectContext = {
      name: name,
      rc: rc,
      state: state,
      refs: refs,
      context: context
    };
    var serviceContext = createServiceBind(service, Object.freeze(callEffectContext));
    var controllerBind = createControllerBind(controller, Object.freeze(_extends({}, callEffectContext, {
      service: serviceContext
    })));
    var viewBind = createViewBind(view, Object.freeze({
      controller: controllerBind,
      state: state,
      refs: refs,
      context: context
    }));
    return Object.freeze({
      state: state,
      refs: refs,
      controller: controllerBind,
      view: viewBind
    });
  }

  var membrane = {};

  var createStoreHook = function createStoreHook(storeConfig) {
    var storeStateConfig = initStateMetaHandler(storeConfig);
    var reducer = reducerHelper(createReducer(storeStateConfig.stateKeys));
    return function useStore() {
      for (var _len = arguments.length, props = new Array(_len), _key = 0; _key < _len; _key++) {
        props[_key] = arguments[_key];
      }

      if (props.length > 0 && !membrane[name]) {
        throw new Error(" \u8FD9\u4E2A store " + name + " \u5E76\u6CA1\u6709\u8BBE\u7F6E membrane, \u4F20\u5165\u7684\u53C2\u6570\u5C06\u4E0D\u4F1A\u8D77\u5230\u4EFB\u4F55\u4F5C\u7528 " + props);
      }

      var context = React.useContext(AppContext);

      var _useReducer = React.useReducer(reducer, storeStateConfig.initState, storeStateConfig.init),
          state = _useReducer[0],
          dispatch = _useReducer[1];

      return createStoreInHook(_extends({
        dispatch: dispatch,
        state: state,
        context: context
      }, storeConfig, storeStateConfig));
    };
  };

  var storeNameList = [];

  function storeNameCheck(name) {
    if (storeNameList.includes(name)) {
      console.error(name + " \u5DF2\u7ECF\u88AB\u5176\u4ED6 store \u4F7F\u7528\u4E86, \u8BF7\u91CD\u65B0\u914D\u7F6E");
    }

    if (name === undefined) {
      throw new Error('配置 store 必须配置 name 字段');
    } else {
      storeNameList.push(name);
    }
  }

  /*!
   * isobject <https://github.com/jonschlinkert/isobject>
   *
   * Copyright (c) 2014-2017, Jon Schlinkert.
   * Released under the MIT License.
   */

  var isobject = function isObject(val) {
    return val != null && typeof val === 'object' && Array.isArray(val) === false;
  };

  var object_pick = function pick(obj, keys) {
    if (!isobject(obj) && typeof obj !== 'function') {
      return {};
    }

    var res = {};
    if (typeof keys === 'string') {
      if (keys in obj) {
        res[keys] = obj[keys];
      }
      return res;
    }

    var len = keys.length;
    var idx = -1;

    while (++idx < len) {
      var key = keys[idx];
      if (key in obj) {
        res[key] = obj[key];
      }
    }
    return res;
  };

  function createStoreBindContext(context, _ref, _ref2, superBindContext, props) {
    var name = _ref.name,
        service = _ref.service,
        controller = _ref.controller,
        view = _ref.view;
    var rc = _ref2.rc,
        refs = _ref2.refs,
        state = _ref2.state;

    var getViewContext = function getViewContext(controllerBind) {
      return {
        controller: controllerBind,
        state: state,
        refs: refs,
        context: context,
        props: props,
        view: view
      };
    };

    var callServiceContext = {
      name: name,
      state: state,
      refs: refs,
      context: context,
      props: props
    };

    if (superBindContext) {
      callServiceContext.super = {
        service: superBindContext.service
      };

      var _serviceBind = createServiceBind(service, Object.freeze(callServiceContext));

      callServiceContext.super.controller = superBindContext.controller;

      var _controllerBind = createControllerBind(controller, Object.freeze(_extends({}, callServiceContext, {
        service: _serviceBind,
        rc: rc
      })));

      var callViewContext = getViewContext(_controllerBind);
      callViewContext.controller = _controllerBind;
      callViewContext.super = {
        view: superBindContext.view,
        controller: superBindContext.controller
      };

      var _viewBind = createViewBind(view, Object.freeze(callViewContext));

      return Object.freeze({
        state: state,
        refs: refs,
        controller: _extends({}, superBindContext.controller, _controllerBind),
        view: _extends({}, superBindContext.view, _viewBind)
      });
    }

    var serviceBind = createServiceBind(service, Object.freeze(callServiceContext));
    var controllerBind = createControllerBind(controller, Object.freeze(_extends({}, callServiceContext, {
      service: serviceBind,
      rc: rc
    })));
    var viewBind = createViewBind(view, Object.freeze(getViewContext(controllerBind)));
    return Object.freeze({
      rc: rc,
      service: serviceBind,
      state: state,
      refs: refs,
      controller: controllerBind,
      view: viewBind
    });
  }

  function createSharedContext(stateKeys, dispatch, state, _ref) {
    var refKeys = _ref.refKeys,
        ref = _ref.ref;
    console.log(stateKeys);
    var rc = createRC(stateKeys, dispatch, state);
    var refs = createRefs(refKeys, ref);
    return {
      rc: rc,
      refs: refs,
      state: state
    };
  }

  function createStoreTakenMembraneHook(storeConfig, membraneStoreConfig) {
    if (!storeConfig.ref) {
      storeConfig.ref = {};
    }

    if (!membraneStoreConfig.ref) {
      membraneStoreConfig.ref = {};
    }

    var storeStateConfig = initStateMetaHandler(storeConfig);
    var membraneStoreStateConfig = initStateMetaHandler(membraneStoreConfig);
    var mergedStateKeys = [].concat(storeStateConfig.stateKeys, membraneStoreStateConfig.stateKeys);
    var reducer = reducerHelper(createReducer(mergedStateKeys));
    return function useMembraneStore(props) {
      var context = React.useContext(AppContext);

      var _useReducer = React.useReducer(reducer, _extends({}, storeStateConfig.initState, membraneStoreStateConfig.initState), function (initArgs) {
        return membraneStoreStateConfig.init(storeStateConfig.init(initArgs));
      }),
          state = _useReducer[0],
          dispatch = _useReducer[1];

      var mergedRef = {
        ref: _extends({}, storeConfig.ref, membraneStoreConfig.ref),
        refKeys: [].concat(storeStateConfig.refKeys, membraneStoreStateConfig.refKeys)
      };
      var sharedContext = createSharedContext(mergedStateKeys, dispatch, state, mergedRef);
      var superBindContext = createStoreBindContext(context, storeConfig, sharedContext);
      var finlayStore = createStoreBindContext(context, membraneStoreConfig, sharedContext, superBindContext, props);
      return Object.freeze({
        state: object_pick(finlayStore.state, storeStateConfig.stateKeys),
        refs: object_pick(finlayStore.refs, storeStateConfig.refKeys),
        controller: object_pick(finlayStore.controller, Object.keys(storeConfig.controller)),
        view: object_pick(finlayStore.view, Object.keys(storeConfig.view))
      });
    };
  }

  var createStore = function createStore(storeConfig) {
    storeNameCheck(storeConfig.name);

    if (storeConfig.membrane) {
      return createStoreTakenMembraneHook(storeConfig, storeConfig.membrane);
    }

    return createStoreHook(storeConfig);
  };

  exports.AppContext = AppContext;
  exports.createStoreContext = createStoreContext;
  exports.default = createStore;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
