import _extends from "@babel/runtime/helpers/esm/extends";
import { log } from '../utils/log';
import { rcsHooks } from '../plugins/rcs-hooks';
export function createServiceBind(service, callEffectContext) {
  if (service) {
    var serviceBind = {};
    var serviceKeys = Object.keys(service);
    serviceKeys.forEach(function (serviceKey) {
      var serviceIsArray = Array.isArray(service[serviceKey]);

      if (serviceIsArray) {
        serviceBind[serviceKey] = function () {
          var _rcsHooks$service, _service$serviceKey$;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          (_rcsHooks$service = rcsHooks.service).beforeRunWithEnhancer.apply(_rcsHooks$service, [serviceKey, service[serviceKey], callEffectContext.name].concat(args));

          var res = (_service$serviceKey$ = service[serviceKey][1]).call.apply(_service$serviceKey$, [_extends({}, callEffectContext, {
            service: serviceBind
          })].concat(args));

          rcsHooks.service.afterRunWithEnhancer(res, serviceKey, service[serviceKey]);
          return res;
        };
      } else {
        serviceBind[serviceKey] = function () {
          var _rcsHooks$service2, _service$serviceKey;

          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          (_rcsHooks$service2 = rcsHooks.service).beforeRun.apply(_rcsHooks$service2, [serviceKey, callEffectContext.name].concat(args));

          var res = (_service$serviceKey = service[serviceKey]).call.apply(_service$serviceKey, [_extends({}, callEffectContext, {
            service: serviceBind
          })].concat(args));

          rcsHooks.service.afterRun(res, serviceKey);
          return res;
        };
      }
    });
    log(serviceBind);
    return serviceBind;
  }

  return {};
}