import _extends from "@babel/runtime/helpers/esm/extends";
import { createControllerBind } from './create-controller-bind';
import { createServiceBind } from './create-service-bind';
import { createViewBind } from './create-view-bind';
export function createStoreBindContext(context, _ref, _ref2, superBindContext, props) {
  var name = _ref.name,
      service = _ref.service,
      controller = _ref.controller,
      view = _ref.view;
  var rc = _ref2.rc,
      refs = _ref2.refs,
      state = _ref2.state;

  var getViewContext = function getViewContext(controllerBind) {
    return {
      controller: controllerBind,
      state: state,
      refs: refs,
      context: context,
      props: props,
      view: view
    };
  };

  var callServiceContext = {
    name: name,
    state: state,
    refs: refs,
    context: context,
    props: props
  };

  if (superBindContext) {
    callServiceContext.super = {
      service: superBindContext.service
    };

    var _serviceBind = createServiceBind(service, Object.freeze(callServiceContext));

    callServiceContext.super.controller = superBindContext.controller;

    var _controllerBind = createControllerBind(controller, Object.freeze(_extends({}, callServiceContext, {
      service: _serviceBind,
      rc: rc
    })));

    var callViewContext = getViewContext(_controllerBind);
    callViewContext.controller = _controllerBind;
    callViewContext.super = {
      view: superBindContext.view,
      controller: superBindContext.controller
    };

    var _viewBind = createViewBind(view, Object.freeze(callViewContext));

    return Object.freeze({
      state: state,
      refs: refs,
      controller: _extends({}, superBindContext.controller, _controllerBind),
      view: _extends({}, superBindContext.view, _viewBind)
    });
  }

  var serviceBind = createServiceBind(service, Object.freeze(callServiceContext));
  var controllerBind = createControllerBind(controller, Object.freeze(_extends({}, callServiceContext, {
    service: serviceBind,
    rc: rc
  })));
  var viewBind = createViewBind(view, Object.freeze(getViewContext(controllerBind)));
  return Object.freeze({
    rc: rc,
    service: serviceBind,
    state: state,
    refs: refs,
    controller: controllerBind,
    view: viewBind
  });
}