import _extends from "@babel/runtime/helpers/esm/extends";
import { useContext, useReducer } from 'react';
import { createReducer, reducerHelper } from './reducer-utils';
import { initStateMetaHandler } from './init-state-meta-handler';
import { AppContext } from './app-context';
import { createStoreInHook } from './create-store-in-hook';
import { membrane } from './create-membrane';
export var createStoreHook = function createStoreHook(storeConfig) {
  var storeStateConfig = initStateMetaHandler(storeConfig);
  var reducer = reducerHelper(createReducer(storeStateConfig.stateKeys));
  return function useStore() {
    for (var _len = arguments.length, props = new Array(_len), _key = 0; _key < _len; _key++) {
      props[_key] = arguments[_key];
    }

    if (props.length > 0 && !membrane[name]) {
      throw new Error(" \u8FD9\u4E2A store " + name + " \u5E76\u6CA1\u6709\u8BBE\u7F6E membrane, \u4F20\u5165\u7684\u53C2\u6570\u5C06\u4E0D\u4F1A\u8D77\u5230\u4EFB\u4F55\u4F5C\u7528 " + props);
    }

    var context = useContext(AppContext);

    var _useReducer = useReducer(reducer, storeStateConfig.initState, storeStateConfig.init),
        state = _useReducer[0],
        dispatch = _useReducer[1];

    return createStoreInHook(_extends({
      dispatch: dispatch,
      state: state,
      context: context
    }, storeConfig, storeStateConfig));
  };
};