import _extends from "@babel/runtime/helpers/esm/extends";
import { createRC } from './reducer-utils';
import { createControllerBind } from './create-controller-bind';
import { createServiceBind } from './create-service-bind';
import { createRefs } from './create-refs';
import { createViewBind } from './create-view-bind';
export function createStoreInHook(_ref) {
  var stateKeys = _ref.stateKeys,
      dispatch = _ref.dispatch,
      state = _ref.state,
      refKeys = _ref.refKeys,
      ref = _ref.ref,
      name = _ref.name,
      context = _ref.context,
      service = _ref.service,
      controller = _ref.controller,
      view = _ref.view;
  var rc = createRC(stateKeys, dispatch, state);
  var refs = createRefs(refKeys, ref);
  var callEffectContext = {
    name: name,
    rc: rc,
    state: state,
    refs: refs,
    context: context
  };
  var serviceContext = createServiceBind(service, Object.freeze(callEffectContext));
  var controllerBind = createControllerBind(controller, Object.freeze(_extends({}, callEffectContext, {
    service: serviceContext
  })));
  var viewBind = createViewBind(view, Object.freeze({
    controller: controllerBind,
    state: state,
    refs: refs,
    context: context
  }));
  return Object.freeze({
    state: state,
    refs: refs,
    controller: controllerBind,
    view: viewBind
  });
}