import _extends from "@babel/runtime/helpers/esm/extends";

/* eslint-disable no-prototype-builtins */
import { log } from '../utils/log';

var getReducerType = function getReducerType(stateKey) {
  return "set" + stateKey.charAt(0).toUpperCase() + stateKey.slice(1);
}; // const getStateKey = (type) => `${type.charAt(3).toLowerCase()}${type.slice(4)}`


export var reducerHelper = function reducerHelper(createReducer) {
  return function (state, action) {
    var reducerModel = createReducer(state);
    log(reducerModel, 5);

    if (reducerModel[action[0]] === undefined) {
      throw new Error("\u4E0D\u5B58\u5728\u7684 action => " + action[0] + ", \u6E05\u6838\u5BF9\u4EE3\u7801");
    }

    var result = reducerModel[action[0]](action[1]);

    if (reducerHelper.debugger) {
      console.group(action[0]);
      console.log('prev store.state =>', state);
      console.log('next state =>', action[1]);
      console.groupEnd();
    }

    return _extends({}, state, result);
  };
};
reducerHelper.debugger = true;
export var createReducer = function createReducer(stateKeys) {
  return function () {
    var reducer = {
      setState: function setState(nextState) {
        return _extends({}, nextState);
      }
    };
    stateKeys.forEach(function (stateKey) {
      var type = getReducerType(stateKey);

      reducer[type] = function (payload) {
        var _ref2;

        if (Array.isArray(payload)) {
          var _ref;

          return _ref = {}, _ref[stateKey] = payload.map(function (p) {
            return p;
          }), _ref;
        }

        return _ref2 = {}, _ref2[stateKey] = payload, _ref2;
      };
    });
    return reducer;
  };
};

function isFunction(value) {
  return typeof value === 'function';
}

export function createRC(stateKeys, dispatch, state) {
  var rc = {
    setState: function setState(nextState) {
      if (isFunction(nextState)) {
        dispatch(['setState', nextState(state)]);
      }

      var nextStateKeys = Object.keys(nextState);
      var ghostKeys = nextStateKeys.filter(function (key) {
        return !stateKeys.includes(key);
      });

      if (ghostKeys.length) {
        throw new Error("\u4E0D\u5B58\u5728\u7684 state => [" + ghostKeys.toString() + "], \u8BF7\u786E\u4FDDsetState\u4E2D\u66F4\u65B0\u7684state\u5728initState\u4E2D\u5DF2\u7ECF\u58F0\u660E");
      } else {
        dispatch(['setState', nextState]);
      }
    }
  };
  stateKeys.forEach(function (stateKey) {
    var type = getReducerType(stateKey);

    rc[type] = function (payload) {
      if (isFunction(payload)) {
        console.log(payload(state[stateKey]), 67);
        dispatch([type, payload(state[stateKey])]);
      } else {
        dispatch([type, payload]);
      }
    };
  });
  return rc;
}