"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.createControllerBind = createControllerBind;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _log = require("../utils/log");

var _rcsHooks = require("../plugins/rcs-hooks");

function createControllerBind(controller, callEffectContext) {
  (0, _log.log)(callEffectContext);

  if (!controller) {
    throw new Error('任何一个 store 都不能没有 controller');
  }

  var controllerKeys = Object.keys(controller);
  var controllerBind = {};
  controllerKeys.forEach(function (controllerKey) {
    var isNotStartWithON = !controllerKey.startsWith('on');

    if (isNotStartWithON) {
      throw new Error(controllerKey + " \u547D\u540D\u5FC5\u987B\u4EE5 on \u5F00\u5934, \u540D\u8BCD + \u52A8\u8BCD\u7ED3\u5C3E");
    }
  });
  controllerKeys.forEach(function (controllerKey) {
    var controllerIsArray = Array.isArray(controller[controllerKey]);
    (0, _log.log)(controller[controllerKey]);
    (0, _log.log)(controllerIsArray);

    if (controllerIsArray) {
      controllerBind[controllerKey] = /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
        var _rcsHooks$controller, _controller$controlle;

        var _len,
            args,
            _key,
            result,
            _args = arguments;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                for (_len = _args.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                  args[_key] = _args[_key];
                }

                (_rcsHooks$controller = _rcsHooks.rcsHooks.controller).beforeRunWithEnhancer.apply(_rcsHooks$controller, [controllerKey, controller[controllerKey], callEffectContext.name].concat(args));

                (0, _log.log)(controller[controllerKey][1], callEffectContext);
                _context.next = 5;
                return (_controller$controlle = controller[controllerKey][1]).call.apply(_controller$controlle, [callEffectContext].concat(args));

              case 5:
                result = _context.sent;

                _rcsHooks.rcsHooks.controller.afterRunWithEnhancer(result, controllerKey);

                return _context.abrupt("return", result);

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
    } else {
      controllerBind[controllerKey] = /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2() {
        var _rcsHooks$controller2, _controller$controlle2;

        var _len2,
            args,
            _key2,
            result,
            _args2 = arguments;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                for (_len2 = _args2.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                  args[_key2] = _args2[_key2];
                }

                (_rcsHooks$controller2 = _rcsHooks.rcsHooks.controller).beforeRun.apply(_rcsHooks$controller2, [controllerKey, callEffectContext.name].concat(args));

                _context2.next = 4;
                return (_controller$controlle2 = controller[controllerKey]).call.apply(_controller$controlle2, [callEffectContext].concat(args));

              case 4:
                result = _context2.sent;

                _rcsHooks.rcsHooks.controller.afterRun(result, controllerKey);

                return _context2.abrupt("return", result);

              case 7:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
    }
  });
  return controllerBind;
}