"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.createStoreBindContext = createStoreBindContext;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _createControllerBind = require("./create-controller-bind");

var _createServiceBind = require("./create-service-bind");

var _createViewBind = require("./create-view-bind");

function createStoreBindContext(context, _ref, _ref2, superBindContext, props) {
  var name = _ref.name,
      service = _ref.service,
      controller = _ref.controller,
      view = _ref.view;
  var rc = _ref2.rc,
      refs = _ref2.refs,
      state = _ref2.state;

  var getViewContext = function getViewContext(controllerBind) {
    return {
      controller: controllerBind,
      state: state,
      refs: refs,
      context: context,
      props: props,
      view: view
    };
  };

  var callServiceContext = {
    name: name,
    state: state,
    refs: refs,
    context: context,
    props: props
  };

  if (superBindContext) {
    callServiceContext.super = {
      service: superBindContext.service
    };

    var _serviceBind = (0, _createServiceBind.createServiceBind)(service, Object.freeze(callServiceContext));

    callServiceContext.super.controller = superBindContext.controller;

    var _controllerBind = (0, _createControllerBind.createControllerBind)(controller, Object.freeze((0, _extends2.default)({}, callServiceContext, {
      service: _serviceBind,
      rc: rc
    })));

    var callViewContext = getViewContext(_controllerBind);
    callViewContext.controller = _controllerBind;
    callViewContext.super = {
      view: superBindContext.view,
      controller: superBindContext.controller
    };

    var _viewBind = (0, _createViewBind.createViewBind)(view, Object.freeze(callViewContext));

    return Object.freeze({
      state: state,
      refs: refs,
      controller: (0, _extends2.default)({}, superBindContext.controller, _controllerBind),
      view: (0, _extends2.default)({}, superBindContext.view, _viewBind)
    });
  }

  var serviceBind = (0, _createServiceBind.createServiceBind)(service, Object.freeze(callServiceContext));
  var controllerBind = (0, _createControllerBind.createControllerBind)(controller, Object.freeze((0, _extends2.default)({}, callServiceContext, {
    service: serviceBind,
    rc: rc
  })));
  var viewBind = (0, _createViewBind.createViewBind)(view, Object.freeze(getViewContext(controllerBind)));
  return Object.freeze({
    rc: rc,
    service: serviceBind,
    state: state,
    refs: refs,
    controller: controllerBind,
    view: viewBind
  });
}