"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.createStoreHook = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = require("react");

var _reducerUtils = require("./reducer-utils");

var _initStateMetaHandler = require("./init-state-meta-handler");

var _appContext = require("./app-context");

var _createStoreInHook = require("./create-store-in-hook");

var _createMembrane = require("./create-membrane");

var createStoreHook = function createStoreHook(storeConfig) {
  var storeStateConfig = (0, _initStateMetaHandler.initStateMetaHandler)(storeConfig);
  var reducer = (0, _reducerUtils.reducerHelper)((0, _reducerUtils.createReducer)(storeStateConfig.stateKeys));
  return function useStore() {
    for (var _len = arguments.length, props = new Array(_len), _key = 0; _key < _len; _key++) {
      props[_key] = arguments[_key];
    }

    if (props.length > 0 && !_createMembrane.membrane[name]) {
      throw new Error(" \u8FD9\u4E2A store " + name + " \u5E76\u6CA1\u6709\u8BBE\u7F6E membrane, \u4F20\u5165\u7684\u53C2\u6570\u5C06\u4E0D\u4F1A\u8D77\u5230\u4EFB\u4F55\u4F5C\u7528 " + props);
    }

    var context = (0, _react.useContext)(_appContext.AppContext);

    var _useReducer = (0, _react.useReducer)(reducer, storeStateConfig.initState, storeStateConfig.init),
        state = _useReducer[0],
        dispatch = _useReducer[1];

    return (0, _createStoreInHook.createStoreInHook)((0, _extends2.default)({
      dispatch: dispatch,
      state: state,
      context: context
    }, storeConfig, storeStateConfig));
  };
};

exports.createStoreHook = createStoreHook;