"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.createStoreInHook = createStoreInHook;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _reducerUtils = require("./reducer-utils");

var _createControllerBind = require("./create-controller-bind");

var _createServiceBind = require("./create-service-bind");

var _createRefs = require("./create-refs");

var _createViewBind = require("./create-view-bind");

function createStoreInHook(_ref) {
  var stateKeys = _ref.stateKeys,
      dispatch = _ref.dispatch,
      state = _ref.state,
      refKeys = _ref.refKeys,
      ref = _ref.ref,
      name = _ref.name,
      context = _ref.context,
      service = _ref.service,
      controller = _ref.controller,
      view = _ref.view;
  var rc = (0, _reducerUtils.createRC)(stateKeys, dispatch, state);
  var refs = (0, _createRefs.createRefs)(refKeys, ref);
  var callEffectContext = {
    name: name,
    rc: rc,
    state: state,
    refs: refs,
    context: context
  };
  var serviceContext = (0, _createServiceBind.createServiceBind)(service, Object.freeze(callEffectContext));
  var controllerBind = (0, _createControllerBind.createControllerBind)(controller, Object.freeze((0, _extends2.default)({}, callEffectContext, {
    service: serviceContext
  })));
  var viewBind = (0, _createViewBind.createViewBind)(view, Object.freeze({
    controller: controllerBind,
    state: state,
    refs: refs,
    context: context
  }));
  return Object.freeze({
    state: state,
    refs: refs,
    controller: controllerBind,
    view: viewBind
  });
}