"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.createStoreTakenMembraneHook = createStoreTakenMembraneHook;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = require("react");

var _object = _interopRequireDefault(require("object.pick"));

var _reducerUtils = require("./reducer-utils");

var _initStateMetaHandler = require("./init-state-meta-handler");

var _appContext = require("./app-context");

var _createStoreBindContext = require("./create-store-bind-context");

var _createSharedContext = require("./create-shared-context");

function createStoreTakenMembraneHook(storeConfig, membraneStoreConfig) {
  if (!storeConfig.ref) {
    storeConfig.ref = {};
  }

  if (!membraneStoreConfig.ref) {
    membraneStoreConfig.ref = {};
  }

  var storeStateConfig = (0, _initStateMetaHandler.initStateMetaHandler)(storeConfig);
  var membraneStoreStateConfig = (0, _initStateMetaHandler.initStateMetaHandler)(membraneStoreConfig);
  var mergedStateKeys = [].concat(storeStateConfig.stateKeys, membraneStoreStateConfig.stateKeys);
  var reducer = (0, _reducerUtils.reducerHelper)((0, _reducerUtils.createReducer)(mergedStateKeys));
  return function useMembraneStore(props) {
    var context = (0, _react.useContext)(_appContext.AppContext);

    var _useReducer = (0, _react.useReducer)(reducer, (0, _extends2.default)({}, storeStateConfig.initState, membraneStoreStateConfig.initState), function (initArgs) {
      return membraneStoreStateConfig.init(storeStateConfig.init(initArgs));
    }),
        state = _useReducer[0],
        dispatch = _useReducer[1];

    var mergedRef = {
      ref: (0, _extends2.default)({}, storeConfig.ref, membraneStoreConfig.ref),
      refKeys: [].concat(storeStateConfig.refKeys, membraneStoreStateConfig.refKeys)
    };
    var sharedContext = (0, _createSharedContext.createSharedContext)(mergedStateKeys, dispatch, state, mergedRef);
    var superBindContext = (0, _createStoreBindContext.createStoreBindContext)(context, storeConfig, sharedContext);
    var finlayStore = (0, _createStoreBindContext.createStoreBindContext)(context, membraneStoreConfig, sharedContext, superBindContext, props);
    return Object.freeze({
      state: (0, _object.default)(finlayStore.state, storeStateConfig.stateKeys),
      refs: (0, _object.default)(finlayStore.refs, storeStateConfig.refKeys),
      controller: (0, _object.default)(finlayStore.controller, Object.keys(storeConfig.controller)),
      view: (0, _object.default)(finlayStore.view, Object.keys(storeConfig.view))
    });
  };
}