"use strict";

exports.__esModule = true;
exports.createStore = void 0;

var _createStoreHook = require("./create-store-hook");

var _storeNameCheck = require("./store-name-check");

var _createStoreTakenMembraneHook = require("./create-store-taken-membrane-hook");

var createStore = function createStore(storeConfig) {
  (0, _storeNameCheck.storeNameCheck)(storeConfig.name);

  if (storeConfig.membrane) {
    return (0, _createStoreTakenMembraneHook.createStoreTakenMembraneHook)(storeConfig, storeConfig.membrane);
  }

  return (0, _createStoreHook.createStoreHook)(storeConfig);
};

exports.createStore = createStore;