"use strict";

exports.__esModule = true;
exports.initStateMetaHandler = initStateMetaHandler;

function initStateMetaHandler(_ref) {
  var initStateMeta = _ref.initState,
      ref = _ref.ref;
  var initStateMetaIsArray = Array.isArray(initStateMeta);
  var initState;
  var init;

  if (initStateMetaIsArray) {
    initState = initStateMeta[0];
    init = initStateMeta[1];
  } else {
    initState = initStateMeta;

    init = function init(state) {
      return state;
    };
  }

  var stateKeys = Object.keys(initState);
  var refKeys;

  if (ref) {
    refKeys = Object.keys(ref);
  }

  return {
    initState: initState,
    stateKeys: stateKeys,
    refKeys: refKeys,
    init: init
  };
}